// ==============================================================
//                ORBITER MODULE: MOBILE3C
//                  Part of the ORBITER SDK
//          Copyright (C) 2001-2002 Martin Schweiger
//                   All rights reserved
//
// MOBILE3C.h
// Class interface for delta glider vessel class module
//
// Notes:
// * This version uses the new thruster definition interface
// ==============================================================

#ifndef __MOBILE3C_H
#define __MOBILE3C_H

#include "orbitersdk.h"
#include "resource.h"

const double FUELMASS = 300;
const double ISP = 11e12;
const double MAXMAINTH = 9000;
const double MAXRETROTH = 9000;
const double MAXRCSTH = 90000;

class MOBILE3C: public VESSEL2 {
public:
	MOBILE3C (OBJHANDLE hVessel, int flightmodel);
	//	: VESSEL2 (hVessel, flightmodel) {}
	void clbkSetClassCaps (FILEHANDLE cfg);
	void DefineAnimations(void);
	void clbkPostStep (double simt, double simdt, double mjd);
    int  clbkConsumeBufferedKey (DWORD key, bool down, char *kstate);
    void clbkVisualCreated (VISHANDLE vis, int refcount);
	void clbkVisualDestroyed (VISHANDLE vis, int refcount);
    void clbkPostCreation (void);
    void MOBILE3C::SelectCockpitView (int whichone); 
    void RevertRDOOR (void);
private:
	
MGROUP_TRANSFORM *TURRENT, *GUN;
enum RDOORStatus { RDOOR_UP, RDOOR_DOWN, RDOOR_RAISING, RDOOR_LOWERING } RDOOR_status;
enum TURRET_check { TM_LEFT, TM_STOP, TM_RIGHT } TURRET_check;
THRUSTER_HANDLE th_main, th_retro,  th_rcs[4], th_group[2] ;
UINT anim_TURRET;
UINT anim_gun;
UINT anim_radar;
UINT anim_reardoor;
UINT anim_reardoor1;
UINT anim_wheel;
UINT anim_wheelleft;
UINT anim_wheelright;
UINT anim_wheelleftrev;
UINT anim_wheelrightrev;
UINT anim_leverleft;
UINT anim_leverright;
UINT anim_leverleft1;
UINT anim_leverright1;
UINT anim_dhandle2;
UINT anim_dhandle1;
int JohnSoundID;
double RDOOR_proc;
double LIFT_SPEED;
double ANT_OPERATING_SPEED;
double ant_proc;
double db;
double ant_check;
double i;
double i3;
double t1;
double main_on;
double retro_on;
double i2l;
double i2r;
double i2;
double pit;
double pit2;
double TURRET_proc;
double GUN_proc;
double GUN_check;
double IGNITION;
};
#endif // !__MOBILE3C_H