
#define STRICT
#define ORBITER_MODULE
#define ENG 				1	
#define START 				2	
#define STOP 				3	
#include "orbitersdk.h"
#include "SHADOCONTROL.h"
#include "OrbiterSoundSDK3.h"
VISHANDLE MainExternalMeshVisual = 0;
void SHADOCONTROL::clbkPostCreation (void)

{
JohnSoundID=ConnectToOrbiterSoundDLL3(GetHandle());
RequestLoadVesselWave3(JohnSoundID,ENG,"Sound\\Vessel\\Mobile\\Mobile-go.wav",BOTHVIEW_FADED_FAR);
RequestLoadVesselWave3(JohnSoundID,START,"Sound\\Vessel\\Mobile\\Mobile-start.wav",BOTHVIEW_FADED_FAR);
SoundOptionOnOff3(JohnSoundID,PLAYMAINTHRUST,FALSE);

SoundOptionOnOff3(JohnSoundID,PLAYHOVERTHRUST,FALSE);
SoundOptionOnOff3(JohnSoundID,PLAYATTITUDETHRUST,FALSE);

SoundOptionOnOff3(JohnSoundID,PLAYCOUNTDOWNWHENTAKEOFF,FALSE);

SoundOptionOnOff3(JohnSoundID,PLAYCABINAIRCONDITIONING,FALSE);

SoundOptionOnOff3(JohnSoundID,PLAYCABINRANDOMAMBIANCE,FALSE);

SoundOptionOnOff3(JohnSoundID,PLAYRADIOATC,FALSE);

SoundOptionOnOff3(JohnSoundID,DISPLAYTIMER,FALSE);
}
SHADOCONTROL::SHADOCONTROL (OBJHANDLE hVessel, int flightmodel)
		: VESSEL2 (hVessel, flightmodel)
{

RDOOR_status = RDOOR_UP;
IGNITION_check = NO_START;
RDOOR_proc = 0;
LIFT_SPEED =.25;
t1 = 1;
i2l = 0.5;
i2r = 0.5;
i2=.5;	
	DefineAnimations ();
	
}
void SHADOCONTROL::SelectCockpitView (int whichone)
{
     switch (whichone) {
       case 0:  //balcony
          SetCameraDefaultDirection (_V(0,0,1));
          SetCameraOffset (_V(-.571,-.074,2.124));
          break;
      case 1:  //command
          SetCameraDefaultDirection (_V(0,0,-1));
          SetCameraOffset (_V(0,.55,-1.307));
          break;

      }
            }
      
// --------------------------------------------------------------
// Set the capabilities of the vessel class
// --------------------------------------------------------------
void SHADOCONTROL::clbkSetClassCaps (FILEHANDLE cfg)
{

	// physical specs
	SetSize (7);
	SetEmptyMass (100.0);
	SetCW (0.3, 0.3, 0.6, 0.9);
	SetWingAspect (0.1);
	SetWingEffectiveness (0.1);
	SetCrossSections (_V(200,30,30));
	SetRotDrag (_V(0.1,0.1,0.1));
	if (GetFlightModel() >= 1) {
		SetPitchMomentScale (1e-4);
		SetBankMomentScale (1e-4);
	}
	SetPMI (_V(57.90, 54.34, 17.13));
	SetTrimScale (0.05);
	SetCameraOffset (_V(-.571,-.074,2.124));
	
	SetTouchdownPoints  (_V(0,-1.87,1), _V(-1.6,-1.87,-1), _V(1.6,-1.87,-1));; 



EnableTransponder (true);


// ==============================================================
// Overloaded callback functions
// ==============================================================

    PROPELLANT_HANDLE TANK;
    TANK = CreatePropellantResource (FUELMASS);

	// ***************** thruster definitions *******************
	

	th_main = CreateThruster (_V(0,0,-4.3), _V(0,0,1), MAXRCSTH, TANK, ISP);
	CreateThrusterGroup (&th_main, 1, THGROUP_MAIN);
		
	th_retro = CreateThruster (_V(0,0,4.3), _V(0,0,-1), MAXRCSTH, TANK, ISP);
	CreateThrusterGroup (&th_retro, 1, THGROUP_RETRO);

	th_rcs[0] = CreateThruster (_V( 1,0, 1), _V(0,0,1),MAXRCSTH, TANK, ISP);
	//left front tread
	th_rcs[1] = CreateThruster (_V(-1,0, 1), _V(0,0,1), MAXRCSTH, TANK, ISP);
	// right front tread
	th_rcs[2] = CreateThruster (_V( 1,0,-1), _V(0,0,-1), MAXRCSTH, TANK, ISP);
	//left rear tread
	th_rcs[3] = CreateThruster (_V(-1,0,-1), _V(0,0,-1), MAXRCSTH, TANK, ISP);
    // right rear tread
	th_group[0] = th_rcs[0];
	th_group[1] = th_rcs[3];
	CreateThrusterGroup (th_group, 2, THGROUP_ATT_YAWLEFT);

	th_group[0] = th_rcs[1];
	th_group[1] = th_rcs[2];
	CreateThrusterGroup (th_group, 2, THGROUP_ATT_YAWRIGHT);
			
			
	// visual specs
			
// visual specs
SetMeshVisibilityMode (AddMesh (oapiLoadMeshGlobal ("shadocontrol")), MESHVIS_ALWAYS); //Main ship mesh
}
// ==============================================================
// API callback interface
// ==============================================================

void SHADOCONTROL::clbkPostStep(double simt, double simdt, double mjd)

{

double vsAirSpeed = GetAirspeed();	
i3 = GetControlSurfaceLevel(AIRCTRL_RUDDER);
//sprintf(oapiDebugString(),"ignition %2.9f mouth %2.3f ",m3ignition,i);	
VECTOR3 speedvec; // first we define our vector which will recieve the data
oapiGetFocusShipAirspeedVector(&speedvec);//then we retrieve its x,y,z

if (GroundContact()==true && GetAirspeed() >13 && (speedvec.z>0))
{AddForce(_V(0,0,-9e3),_V(0,0,0));}

if (GroundContact()==true && GetAirspeed() >13 && (speedvec.z<0))
{AddForce(_V(0,0,9e3),_V(0,0,0));}

double da = simdt * LIFT_SPEED;
            radar_proc += da;
            if( radar_proc > 1.0 ) 
                radar_proc = 0;
        SetAnimation( anim_radar, radar_proc );

 //Anim Wheels Forward
 
 if (GetThrusterLevel (th_main) >0 && i3 == 0)
 {
    if (i > 1)i=0;
    
    if (vsAirSpeed > 0.15) {
	    
	    if (vsAirSpeed > 55) vsAirSpeed = 55;

    
    if (i > 1)i=0;
    i = i + (vsAirSpeed /300);
     
    if (vsAirSpeed ==0) i=0;
    
  // sprintf(oapiDebugString(),"anim %2.2f", i );
    
	SetAnimation (anim_wheelright, i);
    SetAnimation (anim_wheelleft, i);
    
    main_on = 1;
    retro_on = 0;
}

}

//Anim Wheels Backward

if (GetThrusterLevel (th_retro) >0 && i3 == 0)

{
    
    if (i < 0)i=1;
    
    if (vsAirSpeed > 0.15) {
	    
	    if (vsAirSpeed > 55) vsAirSpeed = 55;

    
    if (i < 0)i=1;
    i = i - (vsAirSpeed /300);
     
    if (vsAirSpeed ==0) i=1;
    
   // sprintf(oapiDebugString(),"anim %2.2f", i );
    
	SetAnimation (anim_wheelright, i);
    SetAnimation (anim_wheelleft, i);
    
     main_on = 0;
    retro_on = 1;
    
}


}


//Anim Wheels Forward and Backward when moving without power

 //Anim Wheels Forward and Backward when moving without power

if (GetThrusterLevel (th_main)  == 0 && GetThrusterLevel (th_retro) == 0 && vsAirSpeed > 0.15 && i3 == 0)

{
    
	
	if (main_on == 0 && retro_on == 1)
	
	{
    if (i < 0)i=1;
    
    if (vsAirSpeed > 0.15) {
	    
	    if (vsAirSpeed > 55) vsAirSpeed = 55;

    
    if (i < 0)i=1;
    i = i - (vsAirSpeed /300);
     
    if (vsAirSpeed ==0) i=1;
    
   // sprintf(oapiDebugString(),"anim %2.2f", i );
    
	SetAnimation (anim_wheelright, i);
    SetAnimation (anim_wheelleft, i);
    
     
    
}
}

if (main_on == 1 && retro_on == 0)
	
	{
    if (i > 1)i=0;
    
    if (vsAirSpeed > 0.15) {
	    
	    if (vsAirSpeed > 55) vsAirSpeed = 55;

    
    if (i >  1)i=0;
    i = i + (vsAirSpeed /300);
     
    if (vsAirSpeed ==0) i=1;
    
   // sprintf(oapiDebugString(),"anim %2.2f", i );
    
	SetAnimation (anim_wheelright, i);
    SetAnimation (anim_wheelleft, i);
    
    
    
    
}
}


}




//Anim Wheels Opposite Forward and Backward when turning

// Left turn
if (i3 < -0.15)

{
    
    if (i < 0)i=1;
    
    
	    if (vsAirSpeed > 55) vsAirSpeed = 55;

    
    if (i < 0)i=1;
    i = i - (0.01 + (vsAirSpeed /100));
     
    if (vsAirSpeed ==0) i=1;
    
   // sprintf(oapiDebugString(),"anim %2.2f", i2 );
    
	SetAnimation (anim_wheelrightrev, i);
    SetAnimation (anim_wheelleft, i);
    
  
}

// Right turn
if (i3 > 0.15)

{
    
    if (i < 0)i=1;
    
    
	    
	    if (vsAirSpeed > 55) vsAirSpeed = 55;

    
    if (i < 0)i=1;
    i = i - (0.01 + (vsAirSpeed /100));
     
    if (vsAirSpeed ==0) i=1;
    
 
    
	SetAnimation (anim_wheelright, i);
    SetAnimation (anim_wheelleftrev, i);
    
   
    
}


    
    //Anim Levers
    //sprintf(oapiDebugString(),"anim %2.2f", ignition );
    // Forward Lever animation
    
    if (GetThrusterLevel (th_main) >0 && i3 == 0)
   //Forward Thrust applied not turning, move levers back 
    {
	    i2=i2 - 0.01;
	    if (i2 < .25) i2=.25;
	    
	    SetAnimation (anim_leverleft, i2);
	    SetAnimation (anim_leverright, i2);
	    SetAnimation (anim_leverleft1, i2);
	    SetAnimation (anim_leverright1, i2);
    }
	
    
       
	    if (GetThrusterLevel (th_main) == 0 && i2 < 0.5 && i3 == 0)
    
    {
	    i2=i2 + 0.01;
	    if (i2 > 0.5) i2= 0.5;
	    // no thrust, return levers to neutral
	    
	    SetAnimation (anim_leverleft, i2);
	    SetAnimation (anim_leverright, i2);
	    SetAnimation (anim_leverleft1, i2);
	    SetAnimation (anim_leverright1, i2);
    }
    
    
    if (GetThrusterLevel (th_main) == 0 && GetThrusterLevel (th_retro) ==0 && i2 == 0.5 && i3 == 0)
    
    {
	    i2 = 0.5;
	   
	  //no thrust, lever neutral  
	    
	    SetAnimation (anim_leverleft, i2);
	    SetAnimation (anim_leverright, i2);
	    SetAnimation (anim_leverleft1, i2);
	    SetAnimation (anim_leverright1, i2);
    }
    
    // Reverse Lever animation
    
    if (GetThrusterLevel (th_retro) >0 && i3 == 0 )
    
    {
	    i2=i2 + 0.01;
	    if (i2 > .75) i2= .75;
	    
	    SetAnimation (anim_leverleft, i2);
	    SetAnimation (anim_leverright, i2);
	    SetAnimation (anim_leverleft1, i2);
	    SetAnimation (anim_leverright1, i2);
    }
	
    //retro thrust move lever forward
       
	    if (GetThrusterLevel (th_retro) == 0 && i2 > 0.5 && i3 == 0)
    
    {
	    i2=i2 - 0.01;
	    if (i2 < 0.5) i2= 0.5;
	    
	 //no retro thrust return levers to neutral
	    
	    SetAnimation (anim_leverleft, i2);
	    SetAnimation (anim_leverright, i2);
	    SetAnimation (anim_leverleft1, i2);
	    SetAnimation (anim_leverright1, i2);
    }
    
    //Turn Lever animation
    
   
    if ( i3 > 0)
    
    {
	    i2= 0.5;
	    i2l = i2l - 0.05;
	    if (i2l < 0) i2l= 0;
	    
	    i2r = i2r + 0.05;
	    if (i2r > 1) i2r= 1;
	    
	    SetAnimation (anim_leverleft, i2l);
	    SetAnimation (anim_leverright, i2r);
	    SetAnimation (anim_leverleft1, i2l);
	    SetAnimation (anim_leverright1, i2r);
    }
    
    if ( i3 == 0 && i2l < 0.5)
    
    {
	    i2l = i2l + 0.05;
	    if (i2l > 0.5) i2l= 0.5;
	    
	    i2r = i2r - 0.05;
	    if (i2r < 0.5) i2r= 0.5;
	    
	    SetAnimation (anim_leverleft, i2l);
	    SetAnimation (anim_leverright, i2r);
	    SetAnimation (anim_leverleft1, i2l);
	    SetAnimation (anim_leverright1, i2r);
    }
    
    
    if ( i3 < 0)
    
    {
	    i2= 0.5;
	    i2l = i2l + 0.05;
	    if (i2l > 1) i2l= 1;
	    
	    i2r = i2r - 0.05;
	    if (i2r < 0) i2r= 0;
	    
	    SetAnimation (anim_leverleft, i2l);
	    SetAnimation (anim_leverright, i2r);
	    SetAnimation (anim_leverleft1, i2l);
	    SetAnimation (anim_leverright1, i2r);
    }
    
    if ( i3 == 0 && i2l > 0.5)
    
    {
	    i2l = i2l - 0.05;
	    if (i2l < 0.5) i2l= 0.5;
	    
	    i2r = i2r + 0.05;
	    if (i2r > 0.5) i2r= 0.5;
	    
	    SetAnimation (anim_leverleft, i2l);
	    SetAnimation (anim_leverright, i2r);
	    SetAnimation (anim_leverleft1, i2l);
	    SetAnimation (anim_leverright1, i2r);
	    
    }
    
 
    
    
       
	
if (RDOOR_status >= RDOOR_RAISING) {
		double da = simdt * LIFT_SPEED;
		if (RDOOR_status == RDOOR_RAISING) {
			if (RDOOR_proc > 0.0) RDOOR_proc = max (0.0, RDOOR_proc-da);
			else                RDOOR_status = RDOOR_UP;
		} else {
			if (RDOOR_proc < 1.0) RDOOR_proc = min (1.0, RDOOR_proc+da);
			else                RDOOR_status = RDOOR_DOWN;
		}
SetAnimation (anim_reardoor, RDOOR_proc);
SetAnimation (anim_dhandle1, RDOOR_proc);	
SetAnimation (anim_dhandle2, RDOOR_proc);	
SetAnimation (anim_reardoor1, RDOOR_proc);



}

// engine sound
 double pit = (vsAirSpeed * pit2) + 11025;
 double sp = (190 +((vsAirSpeed)*5));
 if (sp>=225)sp=225;

if (IGNITION_check == YES_START) 
{     
    PlayVesselWave3(JohnSoundID,ENG,LOOP,sp,pit);

// Only turn on the engine sound if it is not already running AND if velocity is >= 10 meters-per-second;
// otherwise, only turn OFF the engine sound if it is running AND if velocity is < 10 meters-per-second.
if (!IsPlaying3(JohnSoundID, ENG) && (vsAirSpeed >= 0))
{
    // turn on the engine sound
    PlayVesselWave3(JohnSoundID,ENG,LOOP,190);
}
else if (IsPlaying3(JohnSoundID, ENG) && (vsAirSpeed < 0))
{
    // turn off the engine sound
    StopVesselWave3(JohnSoundID, ENG);
}
}



// -------------------- added ------------------------------------

if (IGNITION_check == NO_START) {
    
        SetThrusterGroupLevel(th_main,0);
		
		SetThrusterLevel(th_main,0);
		
		SetThrusterMax0 (th_main ,0);
		
		SetThrusterGroupLevel(th_retro,0);
		
		SetThrusterLevel(th_retro,0);
		
		SetThrusterMax0 (th_retro ,0);
		
		
		SetThrusterLevel (th_rcs[0], 0);
		SetThrusterMax0 (th_rcs[0] ,0);
		
        SetThrusterLevel (th_rcs[1], 0);
        SetThrusterMax0 (th_rcs[1] ,0);
        
        SetThrusterLevel (th_rcs[2], 0);
        SetThrusterMax0 (th_rcs[2] ,0);
        
        SetThrusterLevel (th_rcs[3], 0);
        SetThrusterMax0 (th_rcs[3] ,0);
        


	
}

 if (IGNITION_check == YES_START){
		
		
		SetThrusterMax0 (th_main ,9000);
		
		
		SetThrusterMax0 (th_retro ,9000);
		
		SetThrusterMax0 (th_rcs[0] ,90000);
		
		SetThrusterMax0 (th_rcs[1] ,90000);
		
		SetThrusterMax0 (th_rcs[2] ,90000);
		
		SetThrusterMax0 (th_rcs[3] ,90000);

	

//------------------------------------------------------------





}

}




void SHADOCONTROL::DefineAnimations(void)
{
//radar
//dockdoor

   	static UINT EGrp20[5] = {43,44,46,98,139};
   
   static MGROUP_ROTATE radar (0,EGrp20, 5, _V(0,1.051,-1.121), _V(0,1,0), (float)(360*RAD));
   
   anim_radar = CreateAnimation (0);
   
   AddAnimationComponent  (anim_radar, 0, 1, &radar);  	
	 
//doorhandles

static UINT LeGrp5[3] = {50,160,162};
   static MGROUP_ROTATE dhandle1 (0,LeGrp5, 3, _V(-.048,.416,-3.211), _V(0,-.25,0.967), (float)(90*RAD));
   static UINT LeGrp6[3] = {49,161,159};
   static MGROUP_ROTATE dhandle2 (0,LeGrp6, 3, _V(.06,.416,-3.211), _V(0,.25,-0.967), (float)(90*RAD));
anim_dhandle1 = CreateAnimation (0);
      
   AddAnimationComponent  (anim_dhandle1, 0, .5, &dhandle1);
   
   anim_dhandle2 = CreateAnimation (0);
   
   AddAnimationComponent  (anim_dhandle2, 0, .5, &dhandle2);  

	
 // Levers
   static UINT LeGrp1[2] = {117,6};
   static MGROUP_ROTATE lever1 (0,LeGrp1, 2, _V(-.707,-.83,2.633), _V(1,0,0), (float)(45*RAD));
   static UINT LeGrp2[2] = {5,116};
   static MGROUP_ROTATE lever2 (0,LeGrp2, 2, _V(-.591,-.83,2.633), _V(1,0,0), (float)(45*RAD));
   
   static UINT LeGrp3[2] = {118,7};
   static MGROUP_ROTATE lever1a (0,LeGrp3, 2, _V(-.707,-.83,2.633), _V(1,0,0), (float)(45*RAD));
   static UINT LeGrp4[2] = {8,119};
   static MGROUP_ROTATE lever2a (0,LeGrp4, 2, _V(-.591,-.83,2.633), _V(1,0,0), (float)(45*RAD));
      
      
   anim_leverleft = CreateAnimation (0);
      
   AddAnimationComponent  (anim_leverleft, 0, 1, &lever1);
   
   anim_leverright = CreateAnimation (0);
   
   AddAnimationComponent  (anim_leverright, 0, 1, &lever2);   
   
   anim_leverleft1 = CreateAnimation (0);
      
   AddAnimationComponent  (anim_leverleft1, 0, 1, &lever1a);
   
   anim_leverright1 = CreateAnimation (0);
   
   AddAnimationComponent  (anim_leverright1, 0, 1, &lever2a);  
   	
	
//dockdoor

   	static UINT EGrp17[6] = {162,160,149,151,19,50};
   
   static MGROUP_ROTATE rdoor (0,EGrp17, 6, _V(-.416,.456,-3.21), _V(0,0.96,.25), (float)(170*RAD));
   
   anim_reardoor = CreateAnimation (0);
   
   AddAnimationComponent  (anim_reardoor, .5, 1, &rdoor);  
   
   static UINT EGrp18[6] = {161,159,152,150,20,49};
   
   static MGROUP_ROTATE rdoor1 (0,EGrp18, 6, _V(.434,.456,-3.21), _V(0,0.96,.25), (float)(-170*RAD));
   
   anim_reardoor1 = CreateAnimation (0);
   
   AddAnimationComponent  (anim_reardoor1, .5, 1, &rdoor1);  
 //wheelL1
 static UINT WGrp1[1] = {105};
   static MGROUP_ROTATE wheel1 (0,WGrp1, 1, _V(-1.262,-1.341,2.068), _V(1,0,0), (float)(t1*360*RAD));
  //wheelL2 
   static UINT WGrp2[1] = {106};
   static MGROUP_ROTATE wheel2 (0,WGrp2, 1, _V(-1.262,-1.341,1.036), _V(1,0,0), (float)(t1*360*RAD));
 //wheelL3   
   static UINT WGrp3[1] = {107};
   static MGROUP_ROTATE wheel3 (0,WGrp3, 1, _V(-1.262,-1.341,.086), _V(1,0,0), (float)(t1*360*RAD));
 //wheelL4  
   static UINT WGrp4[1] = {108};
   static MGROUP_ROTATE wheel4 (0,WGrp4, 1, _V(-1.262,-1.341,-.822), _V(1,0,0), (float)(t1*360*RAD));
  //wheelL5 
   static UINT WGrp5[1] = {109};
   static MGROUP_ROTATE wheel5 (0,WGrp5, 1, _V(-1.262,-1.341,-1.788), _V(1,0,0), (float)(t1*360*RAD));
   //wheelL6
   static UINT WGrp6[2] = {110};
   static MGROUP_ROTATE wheel6 (0,WGrp6, 1, _V(-1.262,-1.228,-2.918), _V(1,0,0), (float)(t1*360*RAD));
  //wheelR1 
   static UINT WGrp7[1] = {104};
   static MGROUP_ROTATE wheel7 (0,WGrp7, 1, _V(1.262,-1.341,2.068), _V(1,0,0), (float)(t1*360*RAD));
     //wheelR2
   static UINT WGrp8[1] = {103};
   static MGROUP_ROTATE wheel8 (0,WGrp8, 1, _V(1.262,-1.341,1.036), _V(1,0,0), (float)(t1*360*RAD));
     //wheelR3
   static UINT WGrp9[1] = {102};
   static MGROUP_ROTATE wheel9 (0,WGrp9, 1, _V(1.262,-1.341,.086), _V(1,0,0), (float)(t1*360*RAD));
     //wheelR4
   static UINT WGrp10[1] = {101};
   static MGROUP_ROTATE wheel10 (0,WGrp10, 1, _V(1.262,-1.341,-.822), _V(1,0,0), (float)(t1*360*RAD));
     //wheelR5
   static UINT WGrp11[1] = {100};
   static MGROUP_ROTATE wheel11 (0,WGrp11, 1, _V(1.262,-1.341,-1.788), _V(1,0,0), (float)(t1*360*RAD));
     //wheelR6
   static UINT WGrp12[1] = {99};
   static MGROUP_ROTATE wheel12 (0,WGrp12, 1, _V(1.262,-1.228,-2.918), _V(1,0,0), (float)(t1*360*RAD));    

   static UINT WGrp13[1] = {105};
   static MGROUP_ROTATE wheel13(0,WGrp13, 1, _V(-1.262,-1.341,2.068), _V(1,0,0), (float)(-360*RAD));
   
   static UINT WGrp14[1] = {106};
   static MGROUP_ROTATE wheel14 (0,WGrp14, 1, _V(-1.262,-1.341,1.036), _V(1,0,0), (float)(-360*RAD));
   
   static UINT WGrp15[1] = {107};
   static MGROUP_ROTATE wheel15 (0,WGrp15, 1, _V(-1.262,-1.341,.086), _V(1,0,0), (float)(-360*RAD));
   
   static UINT WGrp16[1] = {108};
   static MGROUP_ROTATE wheel16 (0,WGrp16, 1, _V(-1.262,-1.341,-.822), _V(1,0,0), (float)(-360*RAD));
   
   static UINT WGrp17[1] = {109};
   static MGROUP_ROTATE wheel17 (0,WGrp17, 1, _V(-1.262,-1.341,-1.788), _V(1,0,0), (float)(-360*RAD));
   
   static UINT WGrp18[1] = {110};
   static MGROUP_ROTATE wheel18 (0,WGrp18, 1, _V(1.262,-1.228,-2.918), _V(1,0,0), (float)(-360*RAD));
  
   static UINT WGrp19[1] = {104};
   static MGROUP_ROTATE wheel19 (0,WGrp19, 1, _V(-1.262,-1.341,2.068), _V(1,0,0), (float)(-360*RAD));
   
   static UINT WGrp20[1] = {103};
   static MGROUP_ROTATE wheel20 (0,WGrp20, 1, _V(1.262,-1.344,1.036), _V(1,0,0), (float)(-360*RAD));
   
   static UINT WGrp21[1] = {102};
   static MGROUP_ROTATE wheel21 (0,WGrp21, 1, _V(1.262,-1.344,.086), _V(1,0,0), (float)(-360*RAD));
   
   static UINT WGrp22[1] = {101};
   static MGROUP_ROTATE wheel22 (0,WGrp22, 1, _V(1.262,-1.344,-.822), _V(1,0,0), (float)(-360*RAD));
   
   static UINT WGrp23[1] = {100};
   static MGROUP_ROTATE wheel23 (0,WGrp23, 1, _V(1.262,-1.341,-1.788), _V(1,0,0), (float)(-360*RAD));
   
   static UINT WGrp24[1] = {99};
   static MGROUP_ROTATE wheel24 (0,WGrp24, 1, _V(1.262,-1.228,-2.918), _V(1,0,0), (float)(-360*RAD));
   
    anim_wheelright = CreateAnimation (0);
   
   AddAnimationComponent  (anim_wheelright, 0, 1, &wheel7);
   AddAnimationComponent  (anim_wheelright, 0, 1, &wheel8);
   AddAnimationComponent  (anim_wheelright, 0, 1, &wheel9);
   AddAnimationComponent  (anim_wheelright, 0, 1, &wheel10);
   AddAnimationComponent  (anim_wheelright, 0, 1, &wheel11);
   AddAnimationComponent  (anim_wheelright, 0, 1, &wheel12);
   
 anim_wheelleft = CreateAnimation (0);
    
   AddAnimationComponent  (anim_wheelleft, 0, 1, &wheel1);
   AddAnimationComponent  (anim_wheelleft, 0, 1, &wheel2);
   AddAnimationComponent  (anim_wheelleft, 0, 1, &wheel3);
   AddAnimationComponent  (anim_wheelleft, 0, 1, &wheel4);
   AddAnimationComponent  (anim_wheelleft, 0, 1, &wheel5);
   AddAnimationComponent  (anim_wheelleft, 0, 1, &wheel6);
   
   anim_wheelrightrev = CreateAnimation (0);
   
   AddAnimationComponent  (anim_wheelrightrev, 0, 1, &wheel19);
   AddAnimationComponent  (anim_wheelrightrev, 0, 1, &wheel20);
   AddAnimationComponent  (anim_wheelrightrev, 0, 1, &wheel21);
   AddAnimationComponent  (anim_wheelrightrev, 0, 1, &wheel22);
   AddAnimationComponent  (anim_wheelrightrev, 0, 1, &wheel23);
   AddAnimationComponent  (anim_wheelrightrev, 0, 1, &wheel24);
   
   anim_wheelleftrev = CreateAnimation (0);
    
   AddAnimationComponent  (anim_wheelleftrev, 0, 1, &wheel13);
   AddAnimationComponent  (anim_wheelleftrev, 0, 1, &wheel14);
   AddAnimationComponent  (anim_wheelleftrev, 0, 1, &wheel15);
   AddAnimationComponent  (anim_wheelleftrev, 0, 1, &wheel16);
   AddAnimationComponent  (anim_wheelleftrev, 0, 1, &wheel17);
   AddAnimationComponent  (anim_wheelleftrev, 0, 1, &wheel18);
         
  
   }
DLLCLBK VESSEL *ovcInit (OBJHANDLE hvessel, int flightmodel)
{
return new SHADOCONTROL (hvessel, flightmodel);
}

DLLCLBK void ovcExit (VESSEL *vessel)
{
if (vessel) delete (SHADOCONTROL*)vessel;
}

// --------------------------------------------------------------
// Keyboard interface handler (buffered key events)
// --------------------------------------------------------------
int SHADOCONTROL::clbkConsumeBufferedKey (DWORD key, bool down, char *kstate)
{
	if (!down) return 0; // only process keydown events

	// if (KEYMOD_SHIFT (kstate)) {

		switch (key) {
		
			
case OAPI_KEY_1: //  airlock
            SelectCockpitView(0);
            return 1;				
case OAPI_KEY_2: //  Elevator CArgo Deck
            SelectCockpitView(1);
            return 1;
            
case OAPI_KEY_D: //  rear door
		{
			RevertRDOOR();
			return 1;
		}

     						
case OAPI_KEY_K: // ignition
          if(IGNITION_check == NO_START)// not started
			{PlayVesselWave3(JohnSoundID,START,NOLOOP,255,22100);//play start wav
			IGNITION_check=YES_START; }// started
			
		
      return 1;
		
}
return 0;
}

// ==============================================================
// Visual Created
// ==============================================================
void SHADOCONTROL::clbkVisualCreated (VISHANDLE vis, int refcount)
{   
	MainExternalMeshVisual = GetMesh(vis,0);
}
// ==============================================================
// Visual destroyed
// ==============================================================
void SHADOCONTROL::clbkVisualDestroyed (VISHANDLE vis, int refcount)
{
	MainExternalMeshVisual = 0;	
}
void SHADOCONTROL::RevertRDOOR (void)
{
	RDOOR_status = ((RDOOR_status == RDOOR_UP || RDOOR_status == RDOOR_RAISING) ?
		RDOOR_LOWERING : RDOOR_RAISING);
}
